
let alphabet = "0123456789".split("");
//var alphabet = "abcdefghijklmnopqrstuvwxyz".split("");
let len = alphabet.length;
let updateInterval = 4000;
let canRun = true;

let svg = d3.select("svg"),
    width = +svg.attr("width"),
    height = +svg.attr("height");
    g = svg.append("g").attr("transform", "translate(32," + ((height / 2) - 50) + ")");


function update(data) {

  let t = d3.transition().duration(updateInterval/2); //set the transition time for moving letters

  console.log(data); //print the incoming data
  
  // JOIN new data with old elements.
  let text = g.selectAll("text")
    .data(data, d => d); //compares current "data" with previous "data"

  // EXIT old elements not present in new data.
  text.exit()
    .attr("class", 
        d => {
          console.log("exit = " + d);  
          return "exit"
        })
    .transition(t/2)
    .attr("y", 250)
    .style("fill-opacity", 0.0)
    .remove();

  // UPDATE old elements present in new data.
  text.attr("class", 
      d => {
        console.log("update = " + d);  
        return "update";
      })
      .transition(t)
      .attr("x", function(d, i) { return i * 32; });

  // ENTER new elements present in new data.
  text.enter().append("text")
    .text(function(d) { return d; })
    .attr("class", 
        d => {
          console.log("enter = " + d);  
          return "enter";
        })
    .attr("y", -250)
    .attr("x", function(d, i) { return i * 32; })
    .style("fill-opacity", 0.0)
    .transition(t)
    .attr("y", 0)
    .style("fill-opacity", 1);
}



// The initial display.
update(alphabet);

// Grab a random sample of letters from the alphabet, in alphabetical order.
d3.interval(function() {
  if (canRun == true) {

    update(
      d3.shuffle(alphabet)
      .slice(0, Math.floor(Math.random() * len ))
      .sort()
      );
  }
},updateInterval);

// Make it so we can pause the animation
d3.select("svg")
.on("click", function() {
  canRun = !canRun;
  console.log("canRun = " + canRun);
});
